2 # Copyright (c) 2007, Nanako Shiraishi
4 USAGE='[ | save | list | show | apply | clear | drop | pop | create ]'
12 TMP="$GIT_DIR/.git-stash.$$"
13 trap 'rm -f "$TMP-*"' 0
18 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
19 git diff-files --quiet --ignore-submodules
25 die "git stash clear with parameters is unimplemented"
27 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
29 git update-ref -d $ref_stash $current
41 # state of the base commit
42 if b_commit=$(git rev-parse --verify HEAD)
44 head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
46 die "You do not have the initial commit yet"
49 if branch=$(git symbolic-ref -q HEAD)
51 branch=${branch#refs/heads/}
55 msg=$(printf '%s: %s' "$branch" "$head")
58 i_tree=$(git write-tree) &&
59 i_commit=$(printf 'index on %s\n' "$msg" |
60 git commit-tree $i_tree -p $b_commit) ||
61 die "Cannot save the current index state"
63 # state of the working tree
66 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
67 GIT_INDEX_FILE="$TMP-index" &&
68 export GIT_INDEX_FILE &&
69 git read-tree -m $i_tree &&
74 die "Cannot save the current worktree state"
77 if test -z "$stash_msg"
79 stash_msg=$(printf 'WIP on %s' "$msg")
81 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
83 w_commit=$(printf '%s\n' "$stash_msg" |
84 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
85 die "Cannot record working tree state"
93 echo 'No local changes to save'
96 test -f "$GIT_DIR/logs/$ref_stash" ||
97 clear_stash || die "Cannot initialize stash"
99 create_stash "$stash_msg"
101 # Make sure the reflog for stash is kept.
102 : >>"$GIT_DIR/logs/$ref_stash"
104 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
105 die "Cannot save the current status"
106 printf 'Saved working directory and index state "%s"\n' "$stash_msg"
110 git rev-parse --verify $ref_stash >/dev/null 2>&1
114 have_stash || return 0
115 git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
116 sed -n -e 's/^[.0-9a-f]* refs\///p'
120 flags=$(git rev-parse --no-revs --flags "$@")
125 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
127 w_commit=$(git rev-parse --verify "$s") &&
128 b_commit=$(git rev-parse --verify "$s^") &&
129 git diff $flags $b_commit $w_commit
133 git diff-files --quiet --ignore-submodules ||
134 die 'Cannot restore on top of a dirty state'
143 # current index state
144 c_tree=$(git write-tree) ||
145 die 'Cannot apply a stash in the middle of a merge'
147 # stash records the work tree, and is a merge between the
148 # base commit (first parent) and the index tree (second parent).
149 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
150 w_tree=$(git rev-parse --verify "$s:") &&
151 b_tree=$(git rev-parse --verify "$s^1:") &&
152 i_tree=$(git rev-parse --verify "$s^2:") ||
153 die "$*: no valid stashed state found"
155 unstashed_index_tree=
156 if test -n "$unstash_index" && test "$b_tree" != "$i_tree"
158 git diff-tree --binary $s^2^..$s^2 | git apply --cached
160 die 'Conflicts in index. Try without --index.'
161 unstashed_index_tree=$(git-write-tree) ||
162 die 'Could not save index tree'
167 GITHEAD_$w_tree='Stashed changes' &&
168 GITHEAD_$c_tree='Updated upstream' &&
169 GITHEAD_$b_tree='Version stash was based on' &&
170 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
173 if git-merge-recursive $b_tree -- $c_tree $w_tree
176 if test -n "$unstashed_index_tree"
178 git read-tree "$unstashed_index_tree"
181 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
182 git read-tree --reset $c_tree &&
183 git update-index --add --stdin <"$a" ||
184 die "Cannot unstage modified files"
189 # Merge conflict; keep the exit status from merge-recursive
191 if test -n "$unstash_index"
193 echo >&2 'Index was not unstashed.'
200 have_stash || die 'No stash entries to drop'
204 set x "$ref_stash@{0}"
207 # Verify supplied argument looks like a stash entry
208 s=$(git rev-parse --revs-only --no-flags "$@") &&
209 git rev-parse --verify "$s:" > /dev/null 2>&1 &&
210 git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
211 git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
212 die "$*: not a valid stashed state"
214 git reflog delete --updateref --rewrite "$@" &&
215 echo "Dropped $* ($s)" || die "$*: Could not drop stash entry"
217 # clear_stash if we just dropped the last stash entry
218 git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
238 save_stash "$*" && git-reset --hard
249 if test $# -gt 0 && test "$1" = create
253 create_stash "$*" && echo "$w_commit"
263 test -z "$unstash_index" || shift
271 echo '(To restore them type "git stash apply")' &&